-- default biome functions that get called if we can't find a a specific biome that works for us
-- The level of action ids that are spawned from the chests
CHEST_LEVEL = 4
dofile("data/scripts/director_helpers.lua")
dofile("data/scripts/director_helpers_design.lua")
dofile("data/scripts/biome_scripts.lua")


RegisterSpawnFunction( 0xff400000, "spawn_scavengers" )
RegisterSpawnFunction( 0xff400080, "spawn_large_enemies" )
RegisterSpawnFunction( 0xffC8C800, "spawn_lamp2" )
RegisterSpawnFunction( 0xff00AC64, "load_pixel_scene4" )
RegisterSpawnFunction( 0xff80FF5A, "spawn_vines" )
RegisterSpawnFunction( 0xff943030, "spawn_dragonspot" )

------------ SMALL ENEMIES ----------------------------------------------------

g_small_enemies =
{
	total_prob = 0,
	-- this is air, so nothing spawns at 0.6
	{
		prob   		= 0.5,
		min_count	= 0,
		max_count	= 0,    
		entity 	= ""
	},
	-- add skullflys after this step
	{
		prob   		= 0.3,
		min_count	= 3,
		max_count	= 6,    
		entity 	= "data/entities/animals/rainforest/fly.xml"
	},
	{
		prob   		= 0.09,
		min_count	= 2,
		max_count	= 2,    
		entity 	= "data/entities/animals/lukki/lukki_longleg.xml"
	},
	{
		prob   		= 0.09,
		min_count	= 2,
		max_count	= 2,    
		entity 	= "data/entities/animals/lukki/lukki.xml"
	},
	{
		prob   		= 0.1,
		min_count	= 2,
		max_count	= 3,    
		entity 	= "data/entities/animals/rainforest/shooterflower.xml"
	},
	{
		prob   		= 0.09,
		min_count	= 2,
		max_count	= 3,    
		entity 	= "data/entities/animals/rainforest/scavenger_poison.xml"
	},
	{
		prob   		= 0.09,
		min_count	= 2,
		max_count	= 2,    
		entity 	= "data/entities/animals/rainforest/scavenger_clusterbomb.xml"
	},
	{
		prob   		= 0.2,
		min_count	= 2,
		max_count	= 2,    
		entity 	= "data/entities/projectiles/mine.xml"
	},
	{
		prob   		= 0.1,
		min_count	= 2,
		max_count	= 2,    
		entity 	= "data/entities/animals/rainforest/bloom.xml"
	},
}


------------ BIG ENEMIES ------------------------------------------------------

g_big_enemies =
{
	total_prob = 0,
	-- this is air, so nothing spawns at 0.6
	{
		prob   		= 0.6,
		min_count	= 0,
		max_count	= 0,    
		entity 	= ""
	},
	-- add skullflys after this step
	{
		prob   		= 0.1,
		min_count	= 3,
		max_count	= 4,    
		entity 	= "data/entities/animals/rainforest/fungus.xml"
	},
	{
		prob   		= 0.09,
		min_count	= 2,
		max_count	= 3,    
		entity 	= "data/entities/animals/lukki/lukki_longleg.xml"
	},
	{
		prob   		= 0.1,
		min_count	= 2,
		max_count	= 2,    
		entity 	= "data/entities/animals/rainforest/bloom.xml"
	},
	{
		prob   		= 0.1,
		min_count	= 2,
		max_count	= 2,    
		entity 	= "data/entities/animals/rainforest/scavenger_mine.xml"
	},
	{
		prob   		= 0.05,
		min_count	= 2,
		max_count	= 3,    
		entities 	= 
		{
			"data/entities/animals/rainforest/scavenger_poison.xml",
			"data/entities/animals/rainforest/scavenger_clusterbomb.xml",
		},
	},
	{
		prob   		= 0.05,
		min_count	= 2,
		max_count	= 3,    
		entities 	= 
		{
			"data/entities/animals/rainforest/scavenger_poison.xml",
			"data/entities/animals/rainforest/scavenger_clusterbomb.xml",
			"data/entities/animals/rainforest/scavenger_heal.xml",
		},
	},
	{
		prob   		= 0.1,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/projectiles/mine.xml"
	},
	{
		prob   		= 0.1,
		min_count	= 2,
		max_count	= 3,    
		entity 	= "data/entities/animals/rainforest/shooterflower.xml"
	},
	{
		prob   		= 0.09,
		min_count	= 2,
		max_count	= 2,    
		entity 	= "data/entities/animals/lukki/lukki.xml"
	},
}

g_unique_enemy =
{
	total_prob = 0,
	-- this is air, so nothing spawns at 0.6
	{
		prob   		= 1.0,
		min_count	= 0,
		max_count	= 0,    
		entity 	= ""
	},
	-- add skullflys after this step
	{
		prob   		= 1.0,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/buildings/physics_cocoon.xml"
	},
	{
		prob   		= 0.1,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/projectiles/mine.xml"
	},
	{
		prob   		= 0.1,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/animals/rainforest/shooterflower.xml"
	},
}

------------ ITEMS ------------------------------------------------------------

g_items =
{
	total_prob = 0,
	-- this is air, so nothing spawns at 0.6
	{
		prob   		= 0,
		min_count	= 0,
		max_count	= 0,    
		entity 	= ""
	},
	-- add skullflys after this step
	{
		prob   		= 5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/items/wand_level_04.xml"
	},
	{
		prob   		= 3,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/items/wand_level_05.xml"
	},
	{
		prob   		= 3,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/items/wand_unshuffle_02.xml"
	},
	{
		prob   		= 3,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/items/wand_unshuffle_03.xml"
	},
}

------------ MISC --------------------------------------

g_nest =
{
	total_prob = 0,
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/buildings/flynest.xml"
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/buildings/spidernest.xml"
	},
}

------------------- Other animals --------------------------

g_large_enemies =
{
	total_prob = 0,
	{
		prob   		= 0.4,
		min_count	= 0,
		max_count	= 0,    
		entity 	= ""
	},
	{
		prob   		= 0.1,
		min_count	= 2,
		max_count	= 3,    
		entity 	= "data/entities/animals/rainforest/shooterflower.xml"
	},
	{
		prob   		= 0.1,
		min_count	= 2,
		max_count	= 3,    
		entity 	= "data/entities/animals/rainforest/fungus.xml"
	},
	{
		prob   		= 0.5,
		min_count	= 2,
		max_count	= 3,    
		entity 	= "data/entities/animals/rainforest/bloom.xml"
	},
	{
		prob   		= 0.09,
		min_count	= 2,
		max_count	= 3,    
		entity 	= "data/entities/animals/lukki/lukki_longleg.xml"
	},
	{
		prob   		= 0.09,
		min_count	= 2,
		max_count	= 2,    
		entity 	= "data/entities/animals/lukki/lukki.xml"
	},
	{
		prob   		= 0.05,
		min_count	= 1,
		max_count	= 1,    
		entities 	= {
			{
				min_count	= 2,
				max_count	= 3,
				entity = "data/entities/animals/rainforest/scavenger_clusterbomb.xml",
			},
			{
				min_count	= 2,
				max_count	= 3,
				entity = "data/entities/animals/rainforest/scavenger_poison.xml",
			},
			"data/entities/animals/rainforest/scavenger_leader.xml",
		}
	},
	{
		prob   		= 0.1,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/projectiles/mine.xml"
	},
}

g_scavengers =
{
	total_prob = 0,
	{
		prob   		= 0.5,
		min_count	= 0,
		max_count	= 0,    
		entity 	= ""
	},
	{
		prob   		= 0.5,
		min_count	= 2,
		max_count	= 3,    
		entities 	=  
		{
			"data/entities/animals/rainforest/scavenger_smg.xml",
			"data/entities/animals/rainforest/scavenger_grenade.xml"
		}
	},
	{
		prob   		= 0.3,
		min_count	= 2,
		max_count	= 3,    
		entity 	= "data/entities/animals/rainforest/flamer.xml"
	},
	{
		prob   		= 0.4,
		min_count	= 2,
		max_count	= 3,    
		entity 	= "data/entities/animals/rainforest/sniper.xml"
	},
	{
		prob   		= 0.2,
		min_count	= 2,
		max_count	= 3,    
		entity 	= "data/entities/animals/rainforest/scavenger_leader.xml"
	},
	{
		prob   		= 0.2,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/projectiles/mine.xml"
	},
	{
		prob   		= 0.1,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/animals/rainforest/scavenger_mine.xml"
	},
}

g_props =
{
	total_prob = 0,
	{
		prob   		= 0.5,
		min_count	= 0,
		max_count	= 0,    
		entity 	= ""
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/props/physics_barrel_radioactive.xml"
	},
	{
		prob   		= 0.2,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/props/physics_barrel_oil.xml"
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/props/physics_box_explosive.xml"
	},
	{
		prob   		= 0.2,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/projectiles/mine.xml"
	},
	{
		prob   		= 0.2,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/props/physics_seamine.xml"
	},
}

g_lamp =
{
	total_prob = 0,
	-- add skullflys after this step
	{
		prob   		= 0.3,
		min_count	= 1,
		max_count	= 1,    
		entity 	= ""
	},
	{
		prob   		= 0.6,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/props/physics_torch_stand.xml"
	},
	{
		prob   		= 0.1,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/projectiles/mine.xml"
	},
}

g_lamp2 =
{
	total_prob = 0,
	-- add skullflys after this step
	{
		prob   		= 0.0,
		min_count	= 1,
		max_count	= 1,    
		entity 	= ""
	},
	{
		prob   		= 1.0,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/props/physics_tubelamp.xml"
	},
}

g_pixel_scene_01 =
{
	total_prob = 0,
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_pit01.png",
		visual_file		= "",
		background_file	= "",
		is_unique		= 0
	},
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_pit02.png",
		visual_file		= "",
		background_file	= "",
		is_unique		= 0
	},
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_pit03.png",
		visual_file		= "",
		background_file	= "",
		is_unique		= 0
	},
	{
		prob   			= 0.8,
		material_file 	= "data/biome_impl/rainforest_oiltank_01.png",
		visual_file		= "data/biome_impl/rainforest_oiltank_01_visual.png",
		background_file	= "",
		is_unique		= 0
	},
}

g_pixel_scene_02 =
{
	total_prob = 0,
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_hut01.png",
		visual_file		= "",
		background_file	= "data/biome_impl/rainforest_hut01_background.png",
		is_unique		= 0
	},
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_hut02.png",
		visual_file		= "",
		background_file	= "",
		is_unique		= 0
	},
	{
		prob   			= 0.4,
		material_file 	= "data/biome_impl/rainforest_base.png",
		visual_file		= "",
		background_file	= "",
		is_unique		= 0
	},
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_hut03.png",
		visual_file		= "",
		background_file	= "",
		is_unique		= 0
	},
	{
		prob   			= 1.2,
		material_file 	= "data/biome_impl/rainforest_symbolroom.png",
		visual_file		= "",
		background_file	= "",
		is_unique		= 0
	},
}

g_pixel_scene_04 =
{
	total_prob = 0,
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_plantlife.png",
		visual_file		= "",
		background_file	= "data/biome_impl/rainforest_plantlife_background.png",
		is_unique		= 0
	},
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_plantlife.png",
		visual_file		= "",
		background_file	= "data/biome_impl/rainforest_plantlife2_background.png",
		is_unique		= 0
	},
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_plantlife.png",
		visual_file		= "",
		background_file	= "data/biome_impl/rainforest_plantlife3_background.png",
		is_unique		= 0
	},
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_plantlife.png",
		visual_file		= "",
		background_file	= "data/biome_impl/rainforest_plantlife4_background.png",
		is_unique		= 0
	},
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_plantlife.png",
		visual_file		= "",
		background_file	= "data/biome_impl/rainforest_plantlife5_background.png",
		is_unique		= 0
	},
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_plantlife.png",
		visual_file		= "",
		background_file	= "data/biome_impl/rainforest_plantlife6_background.png",
		is_unique		= 0
	},
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_plantlife.png",
		visual_file		= "",
		background_file	= "data/biome_impl/rainforest_plantlife7_background.png",
		is_unique		= 0
	},
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_plantlife.png",
		visual_file		= "",
		background_file	= "data/biome_impl/rainforest_plantlife8_background.png",
		is_unique		= 0
	},
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_plantlife.png",
		visual_file		= "",
		background_file	= "data/biome_impl/rainforest_plantlife9_background.png",
		is_unique		= 0
	},
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_plantlife.png",
		visual_file		= "",
		background_file	= "data/biome_impl/rainforest_plantlife10_background.png",
		is_unique		= 0
	},
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_plantlife.png",
		visual_file		= "",
		background_file	= "data/biome_impl/rainforest_plantlife11_background.png",
		is_unique		= 0
	},
	{
		prob   			= 0.5,
		material_file 	= "data/biome_impl/rainforest_plantlife.png",
		visual_file		= "",
		background_file	= "data/biome_impl/rainforest_plantlife12_background.png",
		is_unique		= 0
	},
}

g_ghostlamp =
{
	total_prob = 0,
	-- add skullflys after this step
	{
		prob   		= 1.0,
		min_count	= 1,
		max_count	= 1,    
		offset_y	= 10,
		entity 	= "data/entities/props/physics_chain_torch_ghostly.xml"
	},
}

g_candles =
{
	total_prob = 0,
	{
		prob   		= 0.33,
		min_count	= 1,
		max_count	= 1, 
		entity 	= "data/entities/props/physics_candle_1.xml"
	},
	{
		prob   		= 0.33,
		min_count	= 1,
		max_count	= 1, 
		entity 	= "data/entities/props/physics_candle_2.xml"
	},
	{
		prob   		= 0.33,
		min_count	= 1,
		max_count	= 1, 
		entity 	= "data/entities/props/physics_candle_3.xml"
	},
}

g_vines =
{
	total_prob = 0,
	{
		prob   		= 0.4,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/verlet_chains/vines/verlet_vine.xml"
	},
	{
		prob   		= 0.3,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/verlet_chains/vines/verlet_vine_long.xml"
	},
	{
		prob   		= 1.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= ""
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/verlet_chains/vines/verlet_vine_short.xml"
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/verlet_chains/vines/verlet_vine_shorter.xml"
	},
}

-- actual functions that get called from the wang generator

function spawn_small_enemies(x, y)
	spawn(g_small_enemies,x,y)
	-- spawn_hp_mult(g_small_enemies,x,y,0,0,2,"rainforest")
end

function spawn_big_enemies(x, y)
	spawn(g_big_enemies,x,y)
	-- spawn_hp_mult(g_big_enemies,x,y,0,0,2,"rainforest")
end

function spawn_unique_enemy(x, y)
	spawn(g_unique_enemy,x,y)
	-- spawn_hp_mult(g_unique_enemy,x,y,0,0,2,"rainforest")
end

function spawn_items(x, y)
	local r = ProceduralRandom( x-11.631, y+10.2257 )
	
	if (r > 0.27) then
		LoadPixelScene( "data/biome_impl/wand_altar.png", "data/biome_impl/wand_altar_visual.png", x-10, y-17, "", true )
	end
end

function spawn_nest(x, y)
	spawn(g_nest,x,y)
end

function spawn_props(x, y)
	spawn(g_props,x,y)
end

function spawn_scavengers(x, y)
	spawn(g_scavengers,x,y)
	-- spawn_hp_mult(g_scavengers,x,y,0,0,2,"rainforest")
end

function spawn_large_enemies(x, y)
	spawn(g_large_enemies,x,y)

	-- spawn_hp_mult(g_large_enemies,x,y,0,0,2,"rainforest")
end

function spawn_lamp(x, y)
	spawn(g_lamp,x,y-10)
end

function spawn_lamp2(x, y)
	spawn(g_lamp2,x,y)
end

function load_pixel_scene( x, y )
	load_random_pixel_scene( g_pixel_scene_01, x, y )
end

function load_pixel_scene2( x, y )
	load_random_pixel_scene( g_pixel_scene_02, x, y )
end

function load_pixel_scene4( x, y )
	load_random_pixel_scene( g_pixel_scene_04, x, y )
end

function spawn_vines(x, y)
	spawn(g_vines,x+5,y+5)
end

function spawn_dragonspot(x, y)
	EntityLoad( "data/entities/buildings/dragonspot.xml", x, y )
end

--[[
function do_hp_scaling( entity_file, biome, hp_multiplier )

	-- local entity_file = "data/entities/animals/fly.xml"
	local x = 10
	local y = 10
	-- local biome = "rainforest"

	if( getPath(entity_file) == "data/entities/animals/" ) then

		-- print( getFilename(entity_file) )
		local entity = EntityLoad( entity_file, x, y)
		local components_damagemodel = EntityGetFirstComponent( entity, "DamageModelComponent" )
		local m_hp = 2
		if components_damagemodel ~= nil then
			m_hp = ComponentGetValue( components_damagemodel, "hp" )
			m_hp = hp_multiplier * m_hp
			ComponentSetValue( components_damagemodel, "max_hp", m_hp )
			ComponentSetValue( components_damagemodel, "hp", m_hp )
		end

		local entity_new_file = getPath( entity_file ) .. biome .. "/" .. getFilename(entity_file)

		-- print( "saving to", getPath( entity_file ) )
		-- EntitySave( entity, entity_file  )
		HAX_WriteEntityHPScale( entity_file, entity_new_file, m_hp )
		EntityKill( entity )
	end
end

function do_hp_scaling_to_table(what, biome, hp_multiplier )
	for k,v in pairs(what) do
		-- print('1')
		-- print(k,v)
		if( v.entity ~= nil ) then
			do_hp_scaling( v.entity, biome, hp_multiplier )
		end
	end
end
]]--
	-- do_hp_scaling_to_table( g_small_enemies, "rainforest", 2.0 )
	-- do_hp_scaling_to_table(g_big_enemies,"rainforest", 2.0)
	-- do_hp_scaling_to_table(g_unique_enemy,"rainforest", 2.0)
	-- do_hp_scaling_to_table(g_scavengers,"rainforest", 2.0)
	-- do_hp_scaling_to_table(g_large_enemies,"rainforest", 2.0)

-- g_big_enemies
-- g_unique_enemy
-- g_large_enemies
-- g_scavengers